GridAverage=100; % Frame size
xyz1=round(xyz/GridAverage,0)*GridAverage; % where xyz is the input point cloud (m*3)

xyz2=unique(xyz1,'rows'); % delete repeat points
xyz2_0=xyz2; % make a copy
% xy plane (only keep the surface points)
for x1=min(xyz2(:,1)):GridAverage:max(xyz2(:,1))
    for y1=min(xyz2(:,2)):GridAverage:max(xyz2(:,2))
        Points=xyz2(xyz2(:,1)==x1&xyz2(:,2)==y1,:);
        if ~isempty(Points)
            if size(Points,1)>2
                xyz2(xyz2(:,1)==x1&xyz2(:,2)==y1&~(xyz2(:,3)==min(Points(:,3))|xyz2(:,3)==max(Points(:,3))),:)=[];
            end
        end
    end
end
% xz plane (only keep the surface points)
for x1=min(xyz2(:,1)):GridAverage:max(xyz2(:,1))
    for z1=min(xyz2(:,3)):GridAverage:max(xyz2(:,3))
        Points=xyz2(xyz2(:,1)==x1&xyz2(:,3)==z1,:);
        if ~isempty(Points)
            if size(Points,1)>2
                xyz2(xyz2(:,1)==x1&xyz2(:,3)==z1&~(xyz2(:,2)==min(Points(:,2))|xyz2(:,2)==max(Points(:,2))),:)=[];
            end
        end
    end
end
% yz plane (only keep the surface points)
for y1=min(xyz2(:,2)):GridAverage:max(xyz2(:,2))
    for z1=min(xyz2(:,3)):GridAverage:max(xyz2(:,3))
        Points=xyz2(xyz2(:,2)==y1&xyz2(:,3)==z1,:);
        if ~isempty(Points)
            if size(Points,1)>2
                xyz2(xyz2(:,2)==y1&xyz2(:,3)==z1&~(xyz2(:,1)==min(Points(:,1))|xyz2(:,1)==max(Points(:,1))),:)=[];
            end
        end
    end
end
k=alphaTriangulation(alphaShape(xyz2)); 
k2=unique([unique(k(:,1:3),'rows');unique(k(:,2:4),'rows');unique(k(:,[1,2,4]),'rows');unique(k(:,[1,3,4]),'rows')],'rows');

xyz3=lpflow_trismooth(xyz2,k2(:,1:3));